--[[---------------------------------------------------------------------------------
  AceM2L2 - by instant0@gmail.com
------------------------------------------------------------------------------------]]
AceM2L2 = LibStub("AceAddon-3.0"):NewAddon("AceM2L2", "AceEvent-3.0","AceConsole-3.0")

--[[--------------------------------------------------------------------------------
  Addon Enabling/Disabling
-----------------------------------------------------------------------------------]]
function AceM2L2:OnEnable()
  	self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN", "C")
  	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE", "R")
end

function AceM2L2:OnDisable()
  	self:UnRegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
  	self:UnRegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")	
end


--[[--------------------------------------------------------------------------------
  Main Processing
-----------------------------------------------------------------------------------]]
function AceM2L2:C(eventname, arg1, ...)
	--DEFAULT_CHAT_FRAME:AddMessage("Something died..." ..arg1)
	local xpT, xpC, x2l, m2l
	for creatureName, xp in string.gmatch(arg1, "(.+) dies, you gain (%d+) experience.") do 
			xpT = UnitXPMax("player")
			xpC = UnitXP("player") + xp
			x2l = xpT - xpC
			m2l = abs(x2l / xp)+1
			if xpC < xpT then 
				DEFAULT_CHAT_FRAME:AddMessage(format(TEXT("%d %s needed for next level"),m2l,creatureName),1,1,255)
			end
		return
	end		
end


-- Rep code

function AceM2L2:R(eventname, arg1, ...)
    local rem = 42000
	  local r = AceM2L2:GetR()
		for faction, rep in string.gmatch(arg1, "Reputation with (.+) increased by (%d+).") do 
			local t = r[faction] or 0;
			local tr = rem - t
			DEFAULT_CHAT_FRAME:AddMessage("["..tr.."] to go with ["..faction.."] = ["..tr/rep.."] repeats (kills/quests)")
		end
end


-- Get rep map, from WowWiki

function AceM2L2:GetR()
	local f  = {}
	local fi = 1

  -- repeats through entire map
	repeat
		local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith,	canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(fi)
		if name == nil then break end
		--DEFAULT_CHAT_FRAME:AddMessage(" ---> "..name)
		if isHeader == nil then
			f[name] = earnedValue;
		end
		fi = fi + 1
	-- assuming no more than 150 factions...
	until fi > 150
	return f
end
